 /*@@
   @file      ParamCheck.F
   @date      Wed May  1 00:56:09 2002
   @author    Ian Hawke
   @desc 
      Routine parameter checking.
   @enddesc 
 @@*/

#include "cctk.h"
#include "cctk_Arguments.h"
#include "cctk_Functions.h"
#include "cctk_Parameters.h"

 /*@@
   @routine    ParamCheck
   @date       Wed May  1 00:56:23 2002
   @author     
   @desc 
      Routine parameter checking.
   @enddesc 
   @calls      
   @calledby   
   @history 
 
   @endhistory 
@@*/

      subroutine ADM_BSSN_ParamCheck(CCTK_ARGUMENTS)

      implicit none

      DECLARE_CCTK_FUNCTIONS
      DECLARE_CCTK_ARGUMENTS
      DECLARE_CCTK_PARAMETERS

      integer :: ierr

c     Check the metric type
c     ---------------------

      if (.not.(CCTK_EQUALS(metric_type,"physical").or.
     .     CCTK_EQUALS(metric_type,"static conformal"))) then 
        call CCTK_PARAMWARN("Unknown metric type for BSSN!")
      end if

c     Check for upwind1
c     -----------------

      if (CCTK_EQUALS(advection,"upwind1")) then
        call CCTK_PARAMWARN("Upwind1 is currently commented out of the BSSN code!")
      end if

      call CCTK_IsImplementationActive(ierr,"MethodOfLines")

      if (ierr .eq. 0) then
        call CCTK_PARAMWARN("MoL or equivalent must be active for BSSN_MoL to give sensible answers!")
      end if

      end subroutine ADM_BSSN_ParamCheck
