/*@@
  @header   BSCHR2_guts.h
  @date     Nov 98
  @author   Gabrielle Allen
  @desc
  Macro to calculate Christoffel symbols of the second kind. 

  That is BSCHR2_cab =  BSg^cd BSCHR1_dab

                   =  1/2 BSg^cd (BSg_ad,b + BSgbd,a - BSgab,d)
  @enddesc
@@*/

#ifndef BSCHR2_GUTS
#define BSCHR2_GUTS

#include "macro/BSCHR1_guts.h"
#include "macro/BSUPPERMET_guts.h"

#ifdef FCODE 

      BSCHR2_XXX = BSCHR1_XXX*BSUPPERMET_UXX + BSCHR1_YXX*BSUPPERMET_UXY + BSCHR1_ZXX*BSUPPERMET_UXZ
      BSCHR2_XXY = BSCHR1_XXY*BSUPPERMET_UXX + BSCHR1_YXY*BSUPPERMET_UXY + BSCHR1_ZXY*BSUPPERMET_UXZ
      BSCHR2_XXZ = BSCHR1_XXZ*BSUPPERMET_UXX + BSCHR1_YXZ*BSUPPERMET_UXY + BSCHR1_ZXZ*BSUPPERMET_UXZ
      BSCHR2_XYY = BSCHR1_XYY*BSUPPERMET_UXX + BSCHR1_YYY*BSUPPERMET_UXY + BSCHR1_ZYY*BSUPPERMET_UXZ
      BSCHR2_XYZ = BSCHR1_XYZ*BSUPPERMET_UXX + BSCHR1_YYZ*BSUPPERMET_UXY + BSCHR1_ZYZ*BSUPPERMET_UXZ
      BSCHR2_XZZ = BSCHR1_XZZ*BSUPPERMET_UXX + BSCHR1_YZZ*BSUPPERMET_UXY + BSCHR1_ZZZ*BSUPPERMET_UXZ
      BSCHR2_YXX = BSCHR1_XXX*BSUPPERMET_UXY + BSCHR1_YXX*BSUPPERMET_UYY + BSCHR1_ZXX*BSUPPERMET_UYZ
      BSCHR2_YXY = BSCHR1_XXY*BSUPPERMET_UXY + BSCHR1_YXY*BSUPPERMET_UYY + BSCHR1_ZXY*BSUPPERMET_UYZ
      BSCHR2_YXZ = BSCHR1_XXZ*BSUPPERMET_UXY + BSCHR1_YXZ*BSUPPERMET_UYY + BSCHR1_ZXZ*BSUPPERMET_UYZ
      BSCHR2_YYY = BSCHR1_XYY*BSUPPERMET_UXY + BSCHR1_YYY*BSUPPERMET_UYY + BSCHR1_ZYY*BSUPPERMET_UYZ
      BSCHR2_YYZ = BSCHR1_XYZ*BSUPPERMET_UXY + BSCHR1_YYZ*BSUPPERMET_UYY + BSCHR1_ZYZ*BSUPPERMET_UYZ
      BSCHR2_YZZ = BSCHR1_XZZ*BSUPPERMET_UXY + BSCHR1_YZZ*BSUPPERMET_UYY + BSCHR1_ZZZ*BSUPPERMET_UYZ
      BSCHR2_ZXX = BSCHR1_XXX*BSUPPERMET_UXZ + BSCHR1_YXX*BSUPPERMET_UYZ + BSCHR1_ZXX*BSUPPERMET_UZZ
      BSCHR2_ZXY = BSCHR1_XXY*BSUPPERMET_UXZ + BSCHR1_YXY*BSUPPERMET_UYZ + BSCHR1_ZXY*BSUPPERMET_UZZ
      BSCHR2_ZXZ = BSCHR1_XXZ*BSUPPERMET_UXZ + BSCHR1_YXZ*BSUPPERMET_UYZ + BSCHR1_ZXZ*BSUPPERMET_UZZ
      BSCHR2_ZYY = BSCHR1_XYY*BSUPPERMET_UXZ + BSCHR1_YYY*BSUPPERMET_UYZ + BSCHR1_ZYY*BSUPPERMET_UZZ
      BSCHR2_ZYZ = BSCHR1_XYZ*BSUPPERMET_UXZ + BSCHR1_YYZ*BSUPPERMET_UYZ + BSCHR1_ZYZ*BSUPPERMET_UZZ
      BSCHR2_ZZZ = BSCHR1_XZZ*BSUPPERMET_UXZ + BSCHR1_YZZ*BSUPPERMET_UYZ + BSCHR1_ZZZ*BSUPPERMET_UZZ

#endif

#ifdef CCODE

      BSCHR2_XXX = BSCHR1_XXX*BSUPPERMET_UXX + BSCHR1_YXX*BSUPPERMET_UXY + BSCHR1_ZXX*BSUPPERMET_UXZ;
      BSCHR2_XXY = BSCHR1_XXY*BSUPPERMET_UXX + BSCHR1_YXY*BSUPPERMET_UXY + BSCHR1_ZXY*BSUPPERMET_UXZ;
      BSCHR2_XXZ = BSCHR1_XXZ*BSUPPERMET_UXX + BSCHR1_YXZ*BSUPPERMET_UXY + BSCHR1_ZXZ*BSUPPERMET_UXZ;
      BSCHR2_XYY = BSCHR1_XYY*BSUPPERMET_UXX + BSCHR1_YYY*BSUPPERMET_UXY + BSCHR1_ZYY*BSUPPERMET_UXZ;
      BSCHR2_XYZ = BSCHR1_XYZ*BSUPPERMET_UXX + BSCHR1_YYZ*BSUPPERMET_UXY + BSCHR1_ZYZ*BSUPPERMET_UXZ;
      BSCHR2_XZZ = BSCHR1_XZZ*BSUPPERMET_UXX + BSCHR1_YZZ*BSUPPERMET_UXY + BSCHR1_ZZZ*BSUPPERMET_UXZ;
      BSCHR2_YXX = BSCHR1_XXX*BSUPPERMET_UXY + BSCHR1_YXX*BSUPPERMET_UYY + BSCHR1_ZXX*BSUPPERMET_UYZ;
      BSCHR2_YXY = BSCHR1_XXY*BSUPPERMET_UXY + BSCHR1_YXY*BSUPPERMET_UYY + BSCHR1_ZXY*BSUPPERMET_UYZ;
      BSCHR2_YXZ = BSCHR1_XXZ*BSUPPERMET_UXY + BSCHR1_YXZ*BSUPPERMET_UYY + BSCHR1_ZXZ*BSUPPERMET_UYZ;
      BSCHR2_YYY = BSCHR1_XYY*BSUPPERMET_UXY + BSCHR1_YYY*BSUPPERMET_UYY + BSCHR1_ZYY*BSUPPERMET_UYZ;
      BSCHR2_YYZ = BSCHR1_XYZ*BSUPPERMET_UXY + BSCHR1_YYZ*BSUPPERMET_UYY + BSCHR1_ZYZ*BSUPPERMET_UYZ;
      BSCHR2_YZZ = BSCHR1_XZZ*BSUPPERMET_UXY + BSCHR1_YZZ*BSUPPERMET_UYY + BSCHR1_ZZZ*BSUPPERMET_UYZ;
      BSCHR2_ZXX = BSCHR1_XXX*BSUPPERMET_UXZ + BSCHR1_YXX*BSUPPERMET_UYZ + BSCHR1_ZXX*BSUPPERMET_UZZ;
      BSCHR2_ZXY = BSCHR1_XXY*BSUPPERMET_UXZ + BSCHR1_YXY*BSUPPERMET_UYZ + BSCHR1_ZXY*BSUPPERMET_UZZ;
      BSCHR2_ZXZ = BSCHR1_XXZ*BSUPPERMET_UXZ + BSCHR1_YXZ*BSUPPERMET_UYZ + BSCHR1_ZXZ*BSUPPERMET_UZZ;
      BSCHR2_ZYY = BSCHR1_XYY*BSUPPERMET_UXZ + BSCHR1_YYY*BSUPPERMET_UYZ + BSCHR1_ZYY*BSUPPERMET_UZZ;
      BSCHR2_ZYZ = BSCHR1_XYZ*BSUPPERMET_UXZ + BSCHR1_YYZ*BSUPPERMET_UYZ + BSCHR1_ZYZ*BSUPPERMET_UZZ;
      BSCHR2_ZZZ = BSCHR1_XZZ*BSUPPERMET_UXZ + BSCHR1_YZZ*BSUPPERMET_UYZ + BSCHR1_ZZZ*BSUPPERMET_UZZ;

#endif

#endif
